#include <iostream>
#include <fstream>

using namespace std;

const int MAXCALL = 1000;

typedef struct {
	int Hour;
	int Min;
	int Sec;
	int secs;
	void secset()
		{
		secs = 60 * 60 * Hour + 60 * Min + Sec;
		}
	} Moment;

typedef struct {
	Moment in;
	Moment out;
	Moment act;
	} Call;

Call calls[MAXCALL + 1];

/*1. feladat + hasznlni is kell*/
int mpbe(int ora, int perc, int mp)
	{
	return 60 * 60 * ora + 60 * perc + mp;
	}

int input();
void stat(int N);
void longest(int N);
void spectime(int N);
void last(int N);
void output(int N);

int main()
	{
	/*2. feladat*/
	int N = input();

	cout << "3. feladat" << endl;
	stat(N);

	cout << "4. feladat" << endl;
	longest(N);

	cout << "5. feladat" << endl;
	spectime(N);

	cout << "6. feladat" << endl;
	last(N);

	//7. feladat
	output(N);

	cout << "kesz" << endl;

	return 0;
	}


int input()
	{
	int n = 0;
	//null-hvs 0:0:0-8:0:0 kozott, vgig foglalt vonallal
	calls[n].in.Hour = 0;
	calls[n].in.Min = 0;
	calls[n].in.Sec = 0;
	calls[n].out.Hour = 8;
	calls[n].out.Min = 0;
	calls[n].out.Sec = 0;
	calls[n].act.Hour = 0;
	calls[n].act.Min = 0;
	calls[n].act.Sec = 0;
	calls[n].in.secset();
	calls[n].act.secset();
	calls[n].out.secs = mpbe(8, 0, 0); //hasznlom az 1. feladat fuggvnyt

	int last = 0; //az eddigi hvsok kozul az utols (aktulis) beszlgeto sorszma
	ifstream fin("hivas.txt");
	int test;
	while(fin >> test) {
			n++;
			calls[n].in.Hour = test;
			fin  >> calls[n].in.Min >> calls[n].in.Sec;
			fin >> calls[n].out.Hour >> calls[n].out.Min >> calls[n].out.Sec;
			calls[n].in.secset();
			calls[n].out.secset();
			/*12 utan erkezo hivs
			vagy 8 elott (null-hivas vege) vagy "last" beszelgetese vege elott letve nem beszelhet
			de Morgan: beszel, ha 12 elott hiv s last beszlgetse vge utn teszi le*/
			if (calls[n].in.secs < mpbe(12, 0, 0) && calls[n].out.secs > calls[last].out.secs) {
					/*beszelgetes kezdete az elotte levo hivas vege s a sajt hivas kezdete kozul a ksobbi*/
					calls[n].act = (calls[n].in.secs > calls[last].out.secs) ? calls[n].in : calls[last].out;
					calls[n].act.secset();
					last = n;     //mostantol o az utolso (aktualis) beszelo
					}
			else calls[n].act.secs = 0;
			}
	fin.close();
	return n;

	}

void stat(int N)
	{
	int hcount[24] = {0};
	for (int i = 1; i <= N; i++)
		hcount[calls[i].in.Hour]++;
	for (int i = 0; i < 24; i++)
		if (hcount[i] != 0 )
			cout << i << " ora " << hcount[i] << " hivas" << endl;
	}

void longest(int N)
	{
	int maxid = 1;
	int maxval = calls[maxid].out.secs - calls[maxid].in.secs;
	for (int i = 2; i <= N; i++)
		if (calls[i].out.secs - calls[i].in.secs > maxval ) {
				maxid = i;
				maxval = calls[maxid].out.secs - calls[maxid].in.secs;
				}
	cout << "A leghosszabb ideig vonalban levo hivo " << maxid << ". sorban szerepel, a hivas hossza: " << maxval << " masodperc." << endl;

	}

void spectime(int N)
	{
	Moment t;
	cout << "Adjon meg egy idopontot! (ora perc masodperc): ";
	cin >> t.Hour >> t.Min >> t.Sec;
	t.secset();

	int active = 0; //beszlgeto sorszma
	int wait = 0;   //ekozben vrakozk szma
	while(active <= N && calls[active].out.secs < t.secs) active++;
	if (active <= N && calls[active].act.secs < t.secs) { //az adott pillanatban valaki beszl
			/* feltesszuk, hogy t.secs tnyleg munkaidoben van. */
			int j = active + 1;                           //a beszlgeto hivst kvetoen
			while(j <= N && calls[j].in.secs <= t.secs) {   //az idopont elotti hvsokon
					if (calls[j].out.secs > t.secs)             //az idopont utn letve
						wait++;
					j++;
					}
			cout << "A varakozok szama: " << wait << " a beszelo a " << active << ". hivo." << endl;
			}
	else
		cout << "Nem volt beszelo." << endl;
	}

void last(int N)
	{
	int last = N;
	while (last > 0 && calls[last].act.secs == 0) last--;
	cout << "Az utolso telefonalo adatai a(z) " << last << ". sorban vannak, ";
	cout << calls[last].act.secs - calls[last].in.secs << " masodpercig vart." << endl;
	}

void output(int N)
	{
	ofstream fout("sikeres.txt");
	for (int i = 1; i <= N; i++)
		if (calls[i].act.secs != 0) {
				fout << i << " " << calls[i].act.Hour << " " << calls[i].act.Min << " " << calls[i].act.Sec;
				fout << " " << calls[i].out.Hour << " " << calls[i].out.Min << " " << calls[i].out.Sec << endl;
				}
	fout.close();
	}
